' grep.VBS V1.00 (C) yoshioka.teruo@nifty.com 2004-09-12
' grep.VBS scans files for regular expression.

Option Explicit
Sub Usage()
WScript.Echo "Usage: CScript grep.VBS [-fir] [folder\]files ..." & _
vbCRLF & "-f: Full path name print" & _
vbCRLF & "-i: Ignore case" & _
vbCRLF & "-r: Recursive" & _
vbCRLF & "-s: Shift JIS" & _
vbCRLF & "-u: UTF-16" & _
vbCRLF & "-8: UTF-8" & _
""
WScript.Quit
End Sub

Dim fso
Dim wShell
Dim arg
Dim Command

Set fso=CreateObject("Scripting.FileSystemObject")
Set wShell=CreateObject("WScript.Shell")

If LCase(fso.GetBaseName(WScript.FullName))="wscript" Then
  Command="Command.com /kCScript.EXE //NoLogo " & """" & WScript.ScriptFullName & """"
  For Each arg In Wscript.Arguments
    Command=Command & " " & """" & arg & """"
  Next
  wShell.Run Command
  WScript.Quit
End If

Dim fFullName
Dim fRecursive
Dim fIgnoreCase
Dim argv()
Dim argc
argc=-1
Dim Pattern
Dim k
Dim opt
Dim charset
Const fUTF16=1
Const fUTF8=2
Const fSJIS=4

For Each arg In WScript.Arguments
If Left(arg,1)="-" Then
  For k=2 To Len(arg)
    opt=Mid(arg,k,1)
    Select Case LCase(opt)
    Case "f" fFullName=True
    Case "r" fRecursive=True
    Case "i" fIgnoreCase=True
    Case "s" charset=charset Or fSJIS
    Case "u" charset=charset Or fUTF16
    Case "8" charset=charset Or fUTF8
    Case Else Call Usage()
    End Select
  Next
Else
  argc=argc+1
  If argc=0 Then
    Pattern=arg
  Else
    ReDim Preserve argv(argc-1)
    argv(argc-1)=arg
  End If
End If
Next
If IsEmpty(charset) Then charset=fSJIS
Dim Home
Dim LenHome
Home=fso.GetAbsolutePathName("")
If Right(Home,1)<>"\" Then Home=Home & "\"
LenHome=Len(Home)
Dim FolderName
Dim FileName
For Each arg In argv
  FolderName=fso.GetParentFolderName(arg)
  FileName=fso.GetFileName(arg)
  If InStr(FileName,"*") Or InStr(FileName,"?") Then
    Call MakePattern()
    If FolderName="" Then FolderName="."
    Call FolderProc(fso.GetFolder(FolderName))
  Else
    Call FileProc(fso.GetFile(arg))
  End IF
Next

WScript.Quit

Dim pre
Dim bre
Dim xre

Sub MakePattern()
Set pre=New RegExp
Set bre=New RegExp
Set xre=New RegExp
pre.Global=True
bre.IgnoreCase=True
xre.IgnoreCase=True
pre.Pattern="([\]\^\[\\\$\+\.\(\)\|\{\}])"
bre.Pattern="^" & pre.Replace(fso.GetBaseName(FileName),"\$1") & "$"
bre.Pattern=Replace(bre.Pattern,"?",".")
bre.Pattern=Replace(bre.Pattern,"*",".*")
xre.Pattern="^" & pre.Replace(fso.GetExtensionName(FileName),"\$1") & "$"
xre.Pattern=Replace(xre.Pattern,"?",".")
xre.Pattern=Replace(xre.Pattern,"*",".*")
pre.Pattern=Pattern
pre.Global=False
pre.IgnoreCase=fIgnoreCase
End Sub

Function FolderProc(Folder)
Dim file
If fRecursive Then
  For Each file In Folder.SubFolders
    Call FolderProc(file)
  Next
End IF

For Each file In Folder.Files
  If bre.Test(fso.GetBaseName(file.Name)) And _
     xre.Test(fso.GetExtensionName(file.Name)) Then
    Call FileProc(file)
  End IF
Next
End Function

Function FileProc(File)
  Dim stream
  Const adTypeBinary=1
  Const adTypeText=2
  Dim CodeSet
  CodeSet=Array("Unicode","utf-8","shift_jis")
  Dim Path
  
  Path=File.Path
  If Not fFullName Then
    If Left(Path,LenHome)=Home Then Path=Mid(Path,LenHome+1)
  End If
  Set stream=CreateObject("ADODB.Stream")
  Call stream.Open()
  stream.Type=adTypeBinary
  Call stream.LoadFromFile(File.Path)
  For k=1 To 3
    If charset and 2^(k-1) Then
      stream.Type=adTypeText
      stream.CharSet=CodeSet(k-1)
      On Error Resume Next
      Call ReadLine(stream,Path)
      If Err Then  WScript.Echo Path,Err.Number,Err.Description,stream.charset
      On Error GoTo 0
      stream.position=0
      stream.Type=adTypeBinary
    End If
  Next
  stream.Close
  Set stream=Nothing
End Function

Sub ReadLine(stream,Path)
  Dim line,lnum
  Const adReadLine = -2

  lnum=0
  Do While Not stream.EOS
    lnum=lnum+1
    line=stream.ReadText(adReadLine)
    If pre.Test(line) Then
      WScript.Echo Path,stream.charset,lnum,line
    End If
  Loop
End Sub
